// mstst32.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "mstst32.h"

#include "mainfrm.h"
#include "mststdoc.h"
#include "mststvw.h"

#include "pardrv.h"
#include "camera.h"
#include "selectfilterdlg.h"

#include <stdio.h>
#include <string.h>

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

static unsigned int timage[164][192];
static unsigned int iimage[510][765];

static void WriteImage(BOOLEAN isTracker);

/////////////////////////////////////////////////////////////////////////////
// CMstst32App

BEGIN_MESSAGE_MAP(CMstst32App, CWinApp)
	//{{AFX_MSG_MAP(CMstst32App)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	ON_COMMAND(ID_CAMERA_ESTABLISH2NDLINK, OnCameraEstablish2ndlink)
	ON_COMMAND(ID_CAMERA_SELECTFILTER, OnCameraSelectFilter)
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
	ON_COMMAND(ID_CAMERA_OPENDRIVER, OnCameraOpenDriver)
	ON_COMMAND(ID_CAMERA_CLOSEDRIVER, OnCameraCloseDriver)
	ON_COMMAND(ID_CAMERA_GETDRIVERINFO, OnCameraGetDriverInfo)
	ON_COMMAND(ID_CAMERA_ESTABLISHLINK, OnCameraEstablishLink)
	ON_COMMAND(ID_CAMERA_GETCCDINFO, OnCameraGetCCDInfo)
	ON_COMMAND(ID_CAMERA_TAKETRACKINGIMAGE, OnCameraTakeTrackingImage)
	ON_COMMAND(ID_CAMERA_TAKEIMAGINGIMAGE, OnCameraTakeImagingImage)
	ON_COMMAND(ID_CAMERA_UPDATECLOCK, OnCameraUpdateClock)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMstst32App construction

CMstst32App::CMstst32App()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CMstst32App object

CMstst32App theApp;

/////////////////////////////////////////////////////////////////////////////
// CMstst32App initialization

BOOL CMstst32App::InitInstance()
{
	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

	Enable3dControls();

	LoadStdProfileSettings();  // Load standard INI file options (including MRU)

	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views.

	CSingleDocTemplate* pDocTemplate;
	pDocTemplate = new CSingleDocTemplate(
		IDR_MAINFRAME,
		RUNTIME_CLASS(CMstst32Doc),
		RUNTIME_CLASS(CMainFrame),       // main SDI frame window
		RUNTIME_CLASS(CMstst32View));
	AddDocTemplate(pDocTemplate);

	// create a new (empty) document
	OnFileNew();

	if (m_lpCmdLine[0] != '\0')
	{
		// TODO: add command line processing here
	}

	// See if running under NT
	OSVERSIONINFO osinfo;
	osinfo.dwOSVersionInfoSize = sizeof(OSVERSIONINFO); 
	GetVersionEx(&osinfo);
	m_bWindowsNT = (osinfo.dwPlatformId == VER_PLATFORM_WIN32_NT);

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

// Implementation
protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//{{AFX_MSG(CAboutDlg)
		// No message handlers
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CMstst32App::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

void CMstst32App::OnCameraOpenDriver()
{
	PAR_ERROR err;
	CString cs;
	OpenDeviceParams odp;

	// TODO: Add your command handler code here
	err = (PAR_ERROR)CameraCommand(CC_OPEN_DRIVER, NULL, NULL);
	if ( err == CE_NO_ERROR )
		cs.Format("Driver opened OK");
	else
		cs.Format("Error %d on CC_OPEN_DRIVER", err);
	MessageBox(NULL, cs, "CC_OPEN_DRIVER", MB_OK);

	if ( m_bWindowsNT ) {
		odp.port = 1;		// Open LPT1
		err = (PAR_ERROR)CameraCommand(CC_OPEN_DEVICE, &odp, NULL);
		if ( err == CE_NO_ERROR )
			cs.Format("Device opened OK");
		else
			cs.Format("Error %d on CC_OPEN_DEVICE", err);
		MessageBox(NULL, cs, "CC_OPEN_DEVICE", MB_OK);
	}
}

void CMstst32App::OnCameraCloseDriver()
{
	PAR_ERROR err;
	CString cs;

	// TODO: Add your command handler code here
	if ( m_bWindowsNT ) {
		err = (PAR_ERROR)CameraCommand(CC_CLOSE_DEVICE, NULL, NULL);
		if ( err == CE_NO_ERROR )
			cs.Format("Device closed OK");
		else
			cs.Format("Error %d on CC_CLOSE_DEVICE", err);
		MessageBox(NULL, cs, "CC_CLOSE_DEVICE", MB_OK);
	}

	err = (PAR_ERROR)CameraCommand(CC_CLOSE_DRIVER, NULL, NULL);
	if ( err == CE_NO_ERROR )
		cs.Format("Driver closed OK");
	else
		cs.Format("Error %d on CC_CLOSE_DRIVER", err);
	MessageBox(NULL, cs, "CC_CLOSE_DRIVER", MB_OK);
}

void CMstst32App::OnCameraGetDriverInfo()
{
	short err;
	CString s, s1;
	GetDriverInfoParams gdip;
	GetDriverInfoResults0 gdir;

	gdip.request = DRIVER_STD;
	err = CameraCommand(CC_GET_DRIVER_INFO, &gdip, &gdir);
	if ( err == CE_NO_ERROR )
	{
		s.Format("Driver Info OK\nVersion = %2x.%02x\nString = %s\n",
		  gdir.version/256, gdir.version % 256, gdir.name);
		gdip.request = DRIVER_EXTENDED;
		err = CameraCommand(CC_GET_DRIVER_INFO, &gdip, &gdir);
		if ( err == CE_NO_ERROR )
			s1.Format("\nExt. Driver Info OK\nVersion = %2x.%02x\nString = %s",
			  gdir.version/256, gdir.version % 256, gdir.name);
		else
			s1.Format("\nError on Ext. driver info: %d", err);
		s += s1;
	}
	else
		s.Format("Error on driver info: %d", err);
	MessageBox(NULL,s, "CC_GET_DRIVER_INFO", MB_OK);
}

void CMstst32App::OnCameraEstablishLink()
{
	short err;
	char s[256];
	EstablishLinkParams elp;
	EstablishLinkResults elr;

	elp.port = BASE_ADDR;
	elp.baseAddress = 0x378;
	err = CameraCommand(CC_ESTABLISH_LINK, &elp, &elr);
	if ( err == CE_NO_ERROR )
		sprintf(s,"Establish link OK\nCamera type = %d",elr.cameraType);
	else
		sprintf(s,"Error on establish link: %d", err);
	MessageBox(NULL,s, "CC_ESTABLISH_LINK", MB_OK);
}

void CMstst32App::OnCameraGetCCDInfo()
{
	short err;
	char s[256];
	GetCCDInfoParams gcip;
	GetCCDInfoResults0 gcir0;

	gcip.request = CCD_INFO_IMAGING;
	err = CameraCommand(CC_GET_CCD_INFO, &gcip, &gcir0);
	if ( err == CE_NO_ERROR )
		sprintf(s,"Get Imaging CCD Info OK\nFirmware = %2x.%02x\nName = %s\nReadout modes = %d",
			gcir0.firmwareVersion/256, gcir0.firmwareVersion % 256, gcir0.name, gcir0.readoutModes);
	else
		sprintf(s,"Error on get ccd info: %d", err);
	MessageBox(NULL,s, "CC_GET_CCD_INFO/CCD_INFO_IMAGING", MB_OK);

	gcip.request = CCD_INFO_TRACKING;
	err = CameraCommand(CC_GET_CCD_INFO, &gcip, &gcir0);
	if ( err == CE_NO_ERROR )
		sprintf(s,"Get Tracking CCD Info OK\nFirmware = %2x.%02x\nName = %s\nReadout modes = %d",
			gcir0.firmwareVersion/256, gcir0.firmwareVersion % 256, gcir0.name, gcir0.readoutModes);
	else
		sprintf(s,"Error on get ccd info: %d", err);
	MessageBox(NULL,s, "CC_GET_CCD_INFO/CCD_INFO_TRACKING", MB_OK);
}

void CMstst32App::OnCameraTakeTrackingImage()
{
 char s[256];
 short i, res;

 StartExposureParams sep;
 EndExposureParams eep;
 QueryCommandStatusParams qcsp;
 QueryCommandStatusResults qcsr;
 ReadoutLineParams rlp;

 ((CMainFrame*)theApp.m_pMainWnd)->m_wndStatusBar.SetPaneText(0, "Taking Tracking CCD Image...");

 /* Start Dark Exposure */
 sep.ccd          = CCD_TRACKING;
 sep.exposureTime = 11;
 sep.abgState     = ABG_CLK_LOW7;
 sep.openShutter  = FALSE;
 res = CameraCommand(CC_START_EXPOSURE, &sep, NULL);
 if( res != CE_NO_ERROR ){
   	sprintf(s,"Start Exposure Error = %d", res);
    MessageBox(NULL, s, "CC_START_EXPOSURE", MB_OK);
    return;
 }

 /* Query Exposure */
 qcsp.command = CC_START_EXPOSURE;
 do{
   	res = CameraCommand(CC_QUERY_COMMAND_STATUS, &qcsp, &qcsr);
    if(res != CE_NO_ERROR){
       sprintf(s,"Query Exposure Error = %d", res);
       MessageBox(NULL, s, "CC_QUERY_COMMAND_STATUS", MB_OK);
       return;
    }
 }while((qcsr.status >> 2) != CS_INTEGRATION_COMPLETE);

 /* End Exposure */
 eep.ccd = CCD_TRACKING;
 res = CameraCommand(CC_END_EXPOSURE, &eep, NULL);
 if(res != CE_NO_ERROR ){
   	sprintf(s,"End Exposure Error = %d", res);
    MessageBox(NULL, s, "CC_END_EXPOSURE", MB_OK);
    return;
 }

 /* Reading Data */
 rlp.ccd = CCD_TRACKING;
 rlp.readoutMode = 0;
 rlp.pixelStart  = 0;
 rlp.pixelLength = 192;
 for(i=0; i<164; i++){
   	 res = CameraCommand(CC_READOUT_LINE, &rlp, timage[i]);
     if(res != CE_NO_ERROR){
        sprintf(s,"Readout Line Error = %d at row %d",res, i);
        MessageBox(NULL, s, "CC_READOUT_LINE", MB_OK);
        return;
     }
 }

 /* Start Light Exposure */
 sep.ccd          = CCD_TRACKING;
 sep.exposureTime = 11;
 sep.abgState     = ABG_CLK_LOW7;
 sep.openShutter  = TRUE;
 res = CameraCommand(CC_START_EXPOSURE, &sep, NULL);
 if( res != CE_NO_ERROR ){
   	sprintf(s,"Start Exposure Error = %d", res);
    MessageBox(NULL, s, "CC_START_EXPOSURE", MB_OK);
    return;
 }

 /* Query Exposure */
 qcsp.command = CC_START_EXPOSURE;
 do{
   	res = CameraCommand(CC_QUERY_COMMAND_STATUS, &qcsp, &qcsr);
    if(res != CE_NO_ERROR){
       sprintf(s,"Query Exposure Error = %d", res);
       MessageBox(NULL, s, "CC_QUERY_COMMAND_STATUS", MB_OK);
       return;
    }
 }while((qcsr.status >> 2) != CS_INTEGRATION_COMPLETE);

 /* End Exposure */
 eep.ccd = CCD_TRACKING;
 res = CameraCommand(CC_END_EXPOSURE, &eep, NULL);
 if(res != CE_NO_ERROR ){
   	sprintf(s,"End Exposure Error = %d", res);
    MessageBox(NULL, s, "CC_END_EXPOSURE", MB_OK);
    return;
 }

 /* Read Substract Line */
 rlp.ccd = CCD_TRACKING;
 rlp.readoutMode = 0;
 rlp.pixelStart  = 0;
 rlp.pixelLength = 192;
 for(i=0; i<164; i++){
   	 res = CameraCommand(CC_READ_SUBTRACT_LINE, &rlp, timage[i]);
     if(res != CE_NO_ERROR){
        sprintf(s,"Readout Line Error = %d at row %d",res, i);
        MessageBox(NULL, s, "CC_READ_SUBTRACT_LINE", MB_OK);
        return;
     }
 }

 ((CMainFrame*)theApp.m_pMainWnd)->m_wndStatusBar.SetPaneText(0, "Image Download Complete");
 MessageBox(NULL, "Image Downloaded fom Tracking CCD", "Image Download", MB_OK);
 WriteImage(TRUE);
}

void CMstst32App::OnCameraTakeImagingImage()
{
 char s[256];
 short i, res;

 StartExposureParams sep;
 EndExposureParams eep;
 QueryCommandStatusParams qcsp;
 QueryCommandStatusResults qcsr;
 ReadoutLineParams rlp;

 ((CMainFrame*)theApp.m_pMainWnd)->m_wndStatusBar.SetPaneText(0, "Taking Imaging CCD Image...");

 /* Start Exposure */
 sep.ccd          = CCD_IMAGING;
 sep.exposureTime = 11;
 sep.abgState     = ABG_LOW7;
 sep.openShutter  = TRUE;
 res = CameraCommand(CC_START_EXPOSURE, &sep, NULL);
 if( res != CE_NO_ERROR ){
   	sprintf(s,"Start Exposure Error = %d", res);
    MessageBox(NULL, s, "CC_START_EXPOSURE", MB_OK);
    return;
 }

 /* Query Exposure */
 qcsp.command = CC_START_EXPOSURE;
 do{
   	res = CameraCommand(CC_QUERY_COMMAND_STATUS, &qcsp, &qcsr);
    if(res != CE_NO_ERROR){
       sprintf(s,"Query Exposure Error = %d", res);
       MessageBox(NULL, s, "CC_QUERY_COMMAND_STATUS", MB_OK);
       return;
    }
 }while(qcsr.status != CS_INTEGRATION_COMPLETE);

 /* End Exposure */
 eep.ccd = CCD_IMAGING;
 res = CameraCommand(CC_END_EXPOSURE, &eep, NULL);
 if(res != CE_NO_ERROR ){
   	sprintf(s,"End Exposure Error = %d", res);
    MessageBox(NULL, s, "CC_END_EXPOSURE", MB_OK);
    return;
 }

 /* Reading Data */
 rlp.ccd = CCD_IMAGING;
 rlp.readoutMode = 0;
 rlp.pixelStart  = 0;
 rlp.pixelLength = 765;
 for(i=0; i<510; i++){
   	 res = CameraCommand(CC_READOUT_LINE, &rlp, iimage[i]);
     if(res != CE_NO_ERROR){
        sprintf(s,"Readout Line Error = %d at row %d",res, i);
        MessageBox(NULL, s, "CC_READOUT_LINE", MB_OK);
        return;
     }
 }

 ((CMainFrame*)theApp.m_pMainWnd)->m_wndStatusBar.SetPaneText(0, "Image Download Complete");
 MessageBox(NULL, "Image Downloaded from Imaging CCD", "Image Download", MB_OK);

 WriteImage(FALSE);
}

void CMstst32App::OnCameraUpdateClock()
{
	short err;
	char s[256];

	err = CameraCommand(CC_UPDATE_CLOCK, NULL, NULL);
	if ( err == CE_NO_ERROR )
		sprintf(s,"Update clock OK");
	else
		sprintf(s,"Error on update clock: %d", err);
	MessageBox(NULL,s, "CC_UPDATE_CLOCK", MB_OK);
}

static void WriteImage(BOOLEAN isTracker)
{
 FILE *hFile;
 short height, width;
 char s[256];
 char fileName[13];

 if ( isTracker )
 {
 	height = 164;
	width = 192;
 	strcpy(fileName, "SBIG_T.ST7");
 }
 else
 {
 	height = 510;
	width = 765;
 	strcpy(fileName, "SBIG_I.ST7");
 }
 hFile = fopen(fileName, "wb");
 fseek(hFile, 0L, SEEK_SET);

 sprintf(s, "ST-7 Image\n\r");
 fwrite(s, strlen(s), 1, hFile);

 sprintf(s, "File_version = 3\n\r");
 fwrite(s, strlen(s), 1, hFile);

 sprintf(s, "Data_version = 1\n\r");
 fwrite(s, strlen(s), 1, hFile);

 sprintf(s, "Exposure = ?\n\r");
 fwrite(s, strlen(s), 1, hFile);

 sprintf(s, "Focal_length = ?\n\r");
 fwrite(s, strlen(s), 1, hFile);

 sprintf(s, "Aperture = ?\n\r");
 fwrite(s, strlen(s), 1, hFile);

 sprintf(s, "Response_factor = ?\n\r");
 fwrite(s, strlen(s), 1, hFile);

 sprintf(s, "Note = TEST IMAGE\n\r");
 fwrite(s, strlen(s), 1, hFile);

 sprintf(s, "Background = 0\n\r");
 fwrite(s, strlen(s), 1, hFile);

 sprintf(s, "Range = 200\n\r");
 fwrite(s, strlen(s), 1, hFile);

 sprintf(s, "Height = %d\n\r", height);
 fwrite(s, strlen(s), 1, hFile);

 sprintf(s, "Width = %d\n\r", width);
 fwrite(s, strlen(s), 1, hFile);

 sprintf(s, "Date = ?\n\r");
 fwrite(s, strlen(s), 1, hFile);

 sprintf(s, "Time = ?\n\r");
 fwrite(s, strlen(s), 1, hFile);

 sprintf(s, "Exposure_state = ?\n\r");
 fwrite(s, strlen(s), 1, hFile);

 sprintf(s, "Temperature = ?\n\r");
 fwrite(s, strlen(s), 1, hFile);

 sprintf(s, "Number_exposures = 1\n\r");
 fwrite(s, strlen(s), 1, hFile);

 sprintf(s, "Each_exposure = 1\n\r");
 fwrite(s, strlen(s), 1, hFile);

 sprintf(s, "History = ?\n\r");
 fwrite(s, strlen(s), 1, hFile);

 sprintf(s, "Observer = SBIG Lab.\n\r");
 fwrite(s, strlen(s), 1, hFile);

 sprintf(s, "X_pixel_size = 0.0090\n\r");
 fwrite(s, strlen(s), 1, hFile);

 sprintf(s, "Y_pixel_size = 0.0090\n\r");
 fwrite(s, strlen(s), 1, hFile);

 sprintf(s, "Pedestal = 0\n\r");
 fwrite(s, strlen(s), 1, hFile);

 sprintf(s, "E_gain = 3\n\r");
 fwrite(s, strlen(s), 1, hFile);

 sprintf(s, "User_1 = MSTST32.EXE\n\r");
 fwrite(s, strlen(s), 1, hFile);

 sprintf(s, "User_2 = -\n\r");
 fwrite(s, strlen(s), 1, hFile);

 sprintf(s, "User_3 = -\n\r");
 fwrite(s, strlen(s), 1, hFile);

 sprintf(s, "User_4 = -\n\r");
 fwrite(s, strlen(s), 1, hFile);

 sprintf(s, "Filter = None\n\r");
 fwrite(s, strlen(s), 1, hFile);

 sprintf(s, "Readout_mode = 0\n\r");
 fwrite(s, strlen(s), 1, hFile);

 sprintf(s, "End\n\r");
 fwrite(s, strlen(s), 1, hFile);

 sprintf(s, "\x1A");
 fwrite(s, strlen(s), 1, hFile);

 fseek(hFile, 2048L, SEEK_SET);

 if ( isTracker )
 {
 	for(short i=0; i<height; i++)
    	fwrite(timage[i], 2*width, 1, hFile);
 }
 else
 {
 	for(short i=0; i<height; i++)
    	fwrite(iimage[i], 2*width, 1, hFile);
 }

 fclose(hFile);

 sprintf(s, "Image ""%s"" was saved.", fileName);
 MessageBox(NULL, s, "Image Save", MB_OK);
}

/////////////////////////////////////////////////////////////////////////////
// CMstst32App commands

void CMstst32App::OnCameraEstablish2ndlink() 
{
	short err;
	CString cmd, s, s1;
	HANDLE h1=INVALID_HANDLE_VALUE, h2=INVALID_HANDLE_VALUE;
	EstablishLinkParams elp;
	EstablishLinkResults elr;
	GetDriverInfoParams gdip;
	GetDriverInfoResults0 gdir;

	do {	/* allow break */
		/* Get the old handle and reste to NULL */
		cmd = "Get 1st Handle";
		if ( (err = CameraCommand(CC_GET_DRIVER_HANDLE, NULL, &h1)) != CE_NO_ERROR )
			break;
		s.Format("%s OK (Handle %08X)", cmd, (DWORD)h1);

		/* Reset Handle */
		cmd = "Set Handle";
		if ( (err = CameraCommand(CC_SET_DRIVER_HANDLE, &h2, NULL)) != CE_NO_ERROR )
			break;
		s1.Format("\n%s OK", cmd);
		s += s1;
		
		/* Open 2nd version of driver */
		cmd = "Open Driver";
		if ( (err = CameraCommand(CC_OPEN_DRIVER, NULL, NULL)) != CE_NO_ERROR )
				break;
		s1.Format("\n%s OK", cmd);
		s += s1;

		/* Get the old handle and reste to NULL */
		cmd = "Get 2nd Handle";
		if ( (err = CameraCommand(CC_GET_DRIVER_HANDLE, NULL, &h2)) != CE_NO_ERROR )
			break;
		s1.Format("\n%s OK (Handle %08X)", cmd, (DWORD)h2);
		s += s1;

		/* Try to establish link on 2nd copy */
		cmd = "Establish Link";
		elp.port = BASE_ADDR;
		elp.baseAddress = 0x378;
		if ( (err = CameraCommand(CC_ESTABLISH_LINK, &elp, &elr)) != CE_NO_ERROR )
			break;
		s1.Format("\n%s OK", cmd);
		s += s1;

		/* Close 2nd driver */
		cmd = "Close 2nd Driver";
		if ( (err = CameraCommand(CC_CLOSE_DRIVER, NULL, NULL)) != CE_NO_ERROR )
			break;
		s1.Format("\n%s OK", cmd);
		s += s1;

		/* Restore Handle */
		cmd = "Restore Handle";
		if ( (err = CameraCommand(CC_SET_DRIVER_HANDLE, &h1, NULL)) != CE_NO_ERROR )
			break;
		s1.Format("\n%s OK", cmd);
		s += s1;


		/* Get Driver Info */
		gdip.request = DRIVER_EXTENDED;
		cmd = "Get Ext. Driver Info";
		if ( (err = CameraCommand(CC_GET_DRIVER_INFO, &gdip, &gdir)) != CE_NO_ERROR )
			break;
		s1.Format("%s OK\nVersion = %2x.%02x\nString = %s", cmd,
			  gdir.version/256, gdir.version % 256, gdir.name);
		s += s1;
	} while (FALSE);
	if ( err != CE_NO_ERROR )
	{
		s1.Format("\nError %d on command %s", err, cmd);
		s += s1;
	}
	s += s1;
	MessageBox(NULL,s, "FYI", MB_OK);
}

void CMstst32App::OnCameraSelectFilter() 
{
	static filter = 0;
	short err;
	PulseOutParams pop;
	CString cs;

	CSelectFilterDlg selDlg;
	selDlg.m_nFilter = filter;
	if ( selDlg.DoModal() == IDOK )
	{
		filter = selDlg.m_nFilter;
		pop.numberPulses = 60;				/* Per CFW-8 App Note */
		pop.pulsePeriod = 18270;
		pop.pulseWidth = 0.435*(1300 + 600 * filter);
		if ( (err = CameraCommand(CC_PULSE_OUT, &pop, NULL)) == CE_NO_ERROR )
			cs.Format("Pulse Out OK");
		else
			cs.Format("Error on Pulse Out:%d", err);

		/* Note! Need to wait for filter to get to position */
		Sleep(3000);

		MessageBox(NULL, cs, "FYI", MB_OK);
	}
}
